#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include "cons.h"

/* Copyright (C) 1992,2000 Bisqwit (http://iki.fi/bisqwit/)
 * No warranty. You are free to modify this source, and to
 * distribute modified sources, as long as you keep the
 * existing copyright messages intact and as long as you
 * remember to add your own copyright markings.
 */

static unsigned xsize, ysize;
static BYTE *map;

static void TranslatePix(BYTE *m)
{
    int c=0x2C, ch='X';
    switch(*m)
    {
        case 0:
        {
            BYTE a=m[-xsize-3],b=m[-xsize-2],d=m[-xsize-1];
            BYTE e=m[-1],  f=m[1];
            BYTE g=m[xsize+1],h=m[xsize+2],i=m[xsize+3];
            c = 8;
            if(a||b||d||e||f||g||h||i)
                if(!a || !i)
                    ch = (b&&d&&e&&f&&g&&h) ? '\\' : '+';
                else if(!d || !g)
                    ch = (a&&b&&e&&f&&h&&i) ? '/' : '+';
                else if(!e || !f)
                    ch = (a&&b&&d&&g&&h&&i) ? '-' : '+';
                else 
                    ch = (a&&d&&e&&f&&g&&i) ? '|' : '+';
            else
                ch = '#';
            break;
        }
        case 1:
            c = 13, ch = '^';
            break;
        case 2:
            c = 5, ch = 'i';
            break;
        case 3:
            c = 14, ch = 'z';
            break;
        case 4:
            c = 6, ch = 'd';
            break;
        case 5:
            c = 15, ch = '?';
            break;
        case 6:
            c = 4, ch = 'V'; /* ?? */
            break;
        case 7:
            c = 5, ch = 'h';
            break;
        case 8:
            c = 8, ch = 'c';
            break;
        case 9: 
            c = 1, ch = 'r';
            break;
        case 10:
            ch = 'A';
            break;
        case 11:
            c = 6, ch = 'b'; /* ?? */
            break;
        case 12:
            c = 6, ch = 'y';
            break;
        case 13:
            c = 15, ch = '%';
            break;
        case 14:
            c = 10, ch = 'f';
            break;
        case 15:
            c = 12, ch = 's';
            break;
        case 16:
            c = 1, ch = 'R';
            break;
        case 17:
            c = 2, ch = 'F';
            break;
        case 18:
            c = 1, ch = '-';
            break;
        case 19:
            c = 10, ch = 'v'; /* ?? */
            break;
        case 20:
            c = 11, ch = 'j'; /* ?? */
            break;
    }
    SetAttr(c);
    Gputchar(ch);
}

static void Viewer(void)
{
    unsigned xp=0, yp=0;
    unsigned y, x;
    InitCons();
Redo:
    if(!kbhit())
        for(y=0; y<LINES; ++y)
        {    
            BYTE *m = map + (1+y+yp)*(xsize+2) + xp+1;
            GotoXY(1,y+1);
            for(x=0; x<COLS; ++x)
                TranslatePix(m++);
        }

    fflush(stdout);
    
    for(;;)
    {
        int key = getkey();
        if(key==Esc || key==''
        || toupper(key)=='Q')break;
        if(key==KbRt && xp<xsize-COLS) { xp += 8; if(xp >= xsize-COLS)xp = xsize-COLS-1; goto Redo;}
        if(key==KbLt) { if(xp > 8)xp -= 8;else xp=0; goto Redo;}
        if(key==KbDn && yp<ysize-LINES) { yp += 8; if(yp >= ysize-LINES)yp = ysize-LINES-1; goto Redo;}
        if(key==KbUp) { if(yp > 8)yp -= 8;else yp=0; goto Redo;}
        if(key=='' || key=='')RefreshScreen();
    }
    
    DoneCons();
}

int main(void)
{
    FILE *fp = fopen("batmap.raw", "rt");
    unsigned y;
    fseek(fp, 8, SEEK_SET);
    
    xsize = fgetc(fp); xsize = fgetc(fp) | (xsize<<8);
    ysize = fgetc(fp); ysize = fgetc(fp) | (ysize<<8);
    
    map = (BYTE *)malloc((xsize+2)*(ysize+2));
    
    fseek(fp, 0x80, SEEK_SET);
    for(y=0; y<ysize; ++y)
        fread(&map[(y+1)*(xsize+2)+1], 1, xsize, fp);
    fclose(fp);
    
    Viewer();
    
    return 0;
}
